let canvas = document.createElement('canvas'),
    b = document.body;
b.innerHTML = 'Press enter';

let started;
canvas.ontouchend = //jos ei toimi puhelimessa touchend voi poistaa
    document.onkeyup = () => {
        if (started) return;
        started = performance.now() / 1000;
        b.innerHTML = '';
        b.style.cursor = 'none';
        b.append(canvas);
        b.requestFullscreen(); //this disabled ray
        //canvas['aspect-ratio'] = 'auto';
        canvas.style.zIndex = -1;
        let text =
            '"Vitruvius, the architect, says in his architectural work that the measurements of man are in nature distributed in this manner, that is 4 fingers make a palm, 4 palms make a foot, 6 palms make a cubit, 4 cubits make a man, 4 cubits make a footstep, 24 palms make a man and these measures are in his buildings. If you open your legs enough that your head is lowered by 1 14th of your height and raise your arms enough, that your extended fingers touch the line of the top of your head, let you know that the center of the ends of the open limbs will be the navel, and the space between the legs will be an equilateral triangle. The length of the outspread arms is equal to the height of the man."';
        //' From the hairline to the bottom of the chin is one-tenth of the height of the man. From below the chin to the top of the head is one-eighth of the height of the man. From above the chest to the top of the head is one-sixth of the height of the man. From above the chest to the hairline is one-seventh of the height of a man. From the chest to the head is a quarter of the height of the man. The maximum width of the shoulders contains a quarter of the man. From the elbow to the tip of the hand is a quarter of the height of a man; the distance from the elbow to the armpit is one-eighth of the height of the man; the length of the hand is one-tenth of the man. The virile member is at the half height of the man. The foot is one-seventh of the man. From below the foot to below the knee is a quarter of the man. From below the knee to the root of the member is a quarter of the man. The distances from the chin to the nose and the hairline and the eyebrows are equal to the ears and one-third of the face"';
        /*let texts = [
        'Vitruvius, the architect, says in his architectural work that the measurements of man are in nature distributed in this manner, that is 4 fingers make a palm,',
        '4 palms make a foot, 6 palms make a cubit, 4 cubits make a man, 4 cubits make a footstep, 24 palms make a man and these measures are in his buildings.',
        'If you open your legs enough that your head is lowered by 1 14th of your height and raise your arms enough that your extended fingers touch the line',
        'of the top of your head, let you know that the center of the ends of the open limbs will be the navel, and the space between the legs will be an equilateral triangle.',
    ];*/
        canvas.style.position = 'absolute';
        canvas.style.left = '0px';
        canvas.style.top = '0px';
        canvas.style.width = '100vw';
        canvas.style.height = '100vh';

        canvas.width = 960;
        canvas.height = 540;
        //let splitted = text.split(',');///[.,]+/);
        //console.log(splitted);
        let lastutter = {};
        let rec, sum;
        text.split(/[.,]+/)
            .concat(['Leonardo da Vinci'])
            .forEach((element, i) => {
                let utter = new SpeechSynthesisUtterance(element);
                utter.lang = i == 15 ? 'it' : 'en-US';
                utter.pitch = 0.5;
                utter.rate = 0.6;
                let recx = () => {
                    textnode.innerHTML = text + '<br><br>Leonardo da Vinci';
                    textnode.style.width = '36vw';
                    textnode.style.fontSize = '1.9vw';
                    textnode.style.color = '#844020';
                    setTimeout(() => {
                        speechSynthesis.speak(utter);
                    }, 1000);
                };
                lastutter.onend = recx;
                if (!rec) rec = recx;
                lastutter = utter;
            });

        let textnode = document.createElement('p');

        textnode.style.position = 'absolute';
        textnode.style.top = '8vw';
        textnode.style.left = '8vw';
        textnode.style.fontSize = '13vw';
        textnode.style.color = '#FFF';
        textnode.innerHTML = 'Vitruvian Man';

        b.append(textnode);

        let ca = 0;
        let na = 0;
        let oa = 0;
        let BGRenderer = (gl) => {
            let vertexShader = `#version 300 es
in vec2 p;out vec2 v;void main(){v=p;gl_Position=vec4(v,0,1);}`;
            /*
            let var_FRAGCOLOR = 'i';
            let var_UBONES = 'uBones';
            let var_UD = 'uD';
            let var_UFRAMES = 'uFrames';
            let var_UMODEL = 'uModel';
            let var_UPOSES = 'uPoses';
            let var_V = 'v';
            const input = `#version 300 es
precision highp float;
in vec2 v;
out vec4 fragColor;

uniform vec4 uModel[132];
uniform vec4 uPoses[247];
uniform vec4 uBones[19];
uniform vec4 uFrames;
uniform vec4 uD;
        
float sdSquareFrame( vec3 p, float b, float e)
{
       p = abs(p -vec3(0.,0.405,0.) )-vec3(b,b,e);
  vec3 q = abs(p+e)-e;
  return min(
    length(max(vec3(p.x,q.y,q.z),0.)),
    length(max(vec3(q.x,p.y,q.z),0.)));
}

float sdRoundCone(vec3 p, vec3 a, vec3 b, float r1, float r2)
{
  vec3  ba = b - a;
  float l2 = dot(ba,ba);
  float rr = r1 - r2;
  float a2 = l2 - rr*rr;
  float il2 = 1./l2;
    
  vec3 pa = p - a;
  float y = dot(pa,ba);
  float z = y - l2;
  float x2 = dot( pa*l2 - ba*y,pa*l2 - ba*y );
  float y2 = y*y*l2;
  float z2 = z*z*l2;

  float k = sign(rr)*rr*rr*x2;
  if( sign(z)*a2*z2>k ) return  sqrt(x2 + z2)        *il2 - r2;
  if( sign(y)*a2*y2<k ) return  sqrt(x2 + y2)        *il2 - r1;
                        return (sqrt(x2*a2*il2)+y*rr)*il2 - r1;
}


float sdTorus( vec3 p)
{
  vec3 op = p-vec3(0,.57 ,0);
  vec2 q = vec2(length(op.xy)-.99,op.z);
  
  return length(q)-0.004;
}

mat4 mTranslate(vec3 v){
    return mat4(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, v.x, v.y, v.z, 1);
}

mat4 qRotationMatrix(vec4 q){
    return mat4(
        1. - 2. * q.y * q.y - 2. * q.z * q.z,
        2. * q.x * q.y - 2. * q.z * q.w,
        2. * q.x * q.z + 2. * q.y * q.w,
        0,
        2. * q.x * q.y + 2. * q.z * q.w,
        1. - 2. * q.x * q.x - 2. * q.z * q.z,
        2. * q.y * q.z - 2. * q.x * q.w,
        0,
        2. * q.x * q.z - 2. * q.y * q.w,
        2. * q.y * q.z + 2. * q.x * q.w,
        1. - 2. * q.x * q.x - 2. * q.y * q.y,
        0,
        0,
        0,
        0,
        1);
}

vec4 qSlerpQ(vec4 qa, vec4 qb, float t){
    float cosHalfTheta = dot(qa,qb);
    if (abs(cosHalfTheta) >= 1.0) {
        return qb;
    }
    float halfTheta = acos(cosHalfTheta);
    float sinHalfTheta = sqrt(1.0 - cosHalfTheta * cosHalfTheta);
    float ratioA = sin((1. - t) * halfTheta) / sinHalfTheta;
    float ratioB = sin(t * halfTheta) / sinHalfTheta;
    return qa * ratioA + qb * ratioB;
    
}

float sdModel(vec3 p, int x){
    
    float mdist =  10.0;
    if(length(p+vec3(0.,-.4 ,.4 ))-1.2 < p.z){
    int f0=int(uFrames.x), f1=int(uFrames.y);

    float t=min(uFrames.z,1.);
    for(int i=0; i<44; i++){
        vec4 a=uModel[3*i]*.01,b=uModel[3*i+1]*.01,info=uModel[3*i+2];
        a.w=b.w=1.;
        int c = int(info.x);
        mat4 m = mat4(0.);
        
        m[0][0] =1.;
        m[1][1] =1.;
        m[2][2] =1.;
        m[3][3] =1.;
        for(int j=0; j<7 ; j++){        
            vec4 rot=qSlerpQ(uPoses[19*f0*x+c]*.01,uPoses[19*f1*x+c]*.01,t);
            vec4 uB = uBones[c];
            m = mTranslate(uB.xyz*.01)*qRotationMatrix(rot)*m;
            c = int(uB.w);
            if(c==-1) break;
        }
        
        mdist = min(mdist,sdRoundCone(p, (m*a).xyz, (m*b).xyz, info.z*.01, info.w*.01));
    }
    }
    return mdist;
}

float map_the_world(vec3 p)
{
    float z =min(min(sdModel(p,1), sdTorus(p)),sdSquareFrame(p, 0.83, 0.004));
    if(.5<uFrames.w) return min(z,sdModel(p,0));
    return z;
}


vec3 calculate_normal(vec3 p)
{
    const vec3 small_step = vec3(.00001, .0, .0);

    float gradient_x = map_the_world(p + small_step.xyy) - map_the_world(p - small_step.xyy);
    float gradient_y = map_the_world(p + small_step.yxy) - map_the_world(p - small_step.yxy);
    float gradient_z = map_the_world(p + small_step.yyx) - map_the_world(p - small_step.yyx);

    vec3 normal = vec3(gradient_x, gradient_y, gradient_z);

    return normalize(normal);
}

vec3 ray_march(vec3 ro, vec3 rd)
{
    float total_distance_traveled = .0;
    const int NUMBER_OF_STEPS = 24;
    const float MINIMUM_HIT_DISTANCE = .001;
    const float MAXIMUM_TRACE_DISTANCE = 5.;

    for (int i = 0; i < NUMBER_OF_STEPS; ++i)
    {
        vec3 current_position = ro + total_distance_traveled * rd;

        float distance_to_closest = map_the_world(current_position);

        if (distance_to_closest < MINIMUM_HIT_DISTANCE) 
        {
            vec3 normal = calculate_normal(current_position);
            vec3 light_position = -vec3(5., 6., 6.);
            vec3 direction_to_light = normalize(current_position - light_position);

            float diffuse_intensity = max(0.0, dot(normal, direction_to_light));
            vec3 color = vec3(.15, .3, .4);
            return color * diffuse_intensity;//+vec3(.05,.05,.05); // leaves ghost
        }

        if (total_distance_traveled > MAXIMUM_TRACE_DISTANCE)
        {
            break;
        }
    
        total_distance_traveled += distance_to_closest;
    }
    return vec3(0.);
}

float vn(vec2 p)
{
float a=0.;
for( int y=-2; y<=2; y++ )
for( int x=-2; x<=2; x++ )
{
    vec2  d = vec2( x, y ) - fract(p) + fract(sin(dot(( floor(p) + vec2(x,y) ),vec2(127.1,311.7)))*43758.5453);
    a+= (1.0-smoothstep(0.,1.,length(d)));
}
return a/2.+.5;
}

void main() {

vec2 vUV= v*vec2(1,uD.z)-vec2(.4,0);
// camera movement	
vec3 ro = vec3( 3.5*cos(uD.y), 0, 3.5*sin(uD.y) );
vec3 ta = vec3( 0, .5, 0 );
// camera matrix
vec3 ww = normalize( ta - ro );
vec3 uu = normalize( cross(ww,vec3(0,1,0) ) );
vec3 vv = normalize( cross(uu,ww));

// create view ray
//vec3 rd = normalize( vUV.x*uu + vUV.y*vv + 1.5*ww ); //moved inline

fragColor = vec4( vec3(1, .95, .89)-max(uD.x-(1.-length(vUV+vec2(.4,0)))*10.,1.)*vn(300.*vUV+100.)*vn( 6.*vUV )*vec3(.7,.9,1)/8.-uD.w*vn(vec2(400.)*(vUV.x-vUV.y)+200.*vUV)*ray_march(ro, normalize( vUV.x*uu + vUV.y*vv + 1.5*ww )), 1. );
}`;
            //*/
            /* File generated with Shader Minifier 1.3.2
             * http://www.ctrl-alt-test.fr
             */
            ///*
            let var_FRAGCOLOR = 'f';
            let var_UBONES = 'n';
            let var_UD = 'l';
            let var_UFRAMES = 'z';
            let var_UMODEL = 'm';
            let var_UPOSES = 'i';
            let var_V = 'v';

            let input = `#version 300 es
precision highp float;in vec2 v;out vec4 f;uniform vec4 m[132],i[247],n[19],z,l;float t(vec3 v,float z,float f){v=abs(v-vec3(0,.405,0))-vec3(z,z,f);vec3 l=abs(v+f)-f;return min(length(max(vec3(v.x,l.yz),0.)),length(max(vec3(l.x,v.y,l.z),0.)));}float t(vec3 v,vec3 z,vec3 m,float e,float y){vec3 l=m-z,f;float x=dot(l,l),w=e-y,i=x-w*w,n=1./x,s,r,c,t,h,k;f=v-z;s=dot(f,l);r=s-x;c=dot(f*x-l*s,f*x-l*s);t=s*s*x;h=r*r*x;k=sign(w)*w*w*c;if(sign(r)*i*h>k)return sqrt(c+h)*n-y;if(sign(s)*i*t<k)return sqrt(c+t)*n-e;return(sqrt(c*i*n)+s*w)*n-e;}float t(vec3 v){vec3 l=v-vec3(0,.57,0);vec2 f=vec2(length(l.xy)-.99,l.z);return length(f)-.004;}mat4 s(vec3 l){return mat4(1,0,0,0,0,1,0,0,0,0,1,0,l.x,l.y,l.z,1);}mat4 h(vec4 l){return mat4(1.-2.*l.y*l.y-2.*l.z*l.z,2.*l.x*l.y-2.*l.z*l.w,2.*l.x*l.z+2.*l.y*l.w,0,2.*l.x*l.y+2.*l.z*l.w,1.-2.*l.x*l.x-2.*l.z*l.z,2.*l.y*l.z-2.*l.x*l.w,0,2.*l.x*l.z-2.*l.y*l.w,2.*l.y*l.z+2.*l.x*l.w,1.-2.*l.x*l.x-2.*l.y*l.y,0,0,0,0,1);}vec4 h(vec4 v,vec4 z,float l){float x=dot(v,z),f,i,w,r;if(abs(x)>=1.)return z;f=acos(x);i=sqrt(1.-x*x);w=sin((1.-l)*f)/i;r=sin(l*f)/i;return v*w+z*r;}float h(vec3 l,int x){float v=10.;if(length(l+vec3(0,-.4,.4))-1.2<l.z){int w=int(z.x),f=int(z.y);float y=min(z.z,1.);for(int r=0;r<44;r++){vec4 c=m[3*r]*.01,e=m[3*r+1]*.01,d=m[3*r+2];c.w=e.w=1.;int k=int(d.x);mat4 o=mat4(0.);o[0][0]=1.;o[1][1]=1.;o[2][2]=1.;o[3][3]=1.;for(int u=0;u<7;u++){vec4 a=h(i[19*w*x+k]*.01,i[19*f*x+k]*.01,y),g=n[k];o=s(g.xyz*.01)*h(a)*o;k=int(g.w);if(k==-1)break;}v=min(v,t(l,(o*c).xyz,(o*e).xyz,d.z*.01,d.w*.01));}}return v;}float e(vec3 v){float l=min(min(h(v,1),t(v)),t(v,.83,.004));if(.5<z.w)return min(l,h(v,0));return l;}vec3 r(vec3 v){const vec3 l=vec3(1e-5,0,0);float z=e(v+l.xyy)-e(v-l.xyy),f=e(v+l.yxy)-e(v-l.yxy),y=e(v+l.yyx)-e(v-l.yyx);vec3 x=vec3(z,f,y);return normalize(x);}vec3 e(vec3 v,vec3 l){float f=0.;for(int x=0;x<24;++x){vec3 z=v+f*l;float m=e(z);if(m<.001){vec3 w=r(z),y=-vec3(5,6,6),i=normalize(z-y),o;float s=max(0.,dot(w,i));o=vec3(.15,.3,.4);return o*s;}if(f>5.)break;f+=m;}return vec3(0);}float x(vec2 v){float f=0.;for(int l=-2;l<=2;l++)for(int z=-2;z<=2;z++){vec2 x=vec2(z,l)-fract(v)+fract(sin(dot(floor(v)+vec2(z,l),vec2(127.1,311.7)))*43758.5453);f+=1.-smoothstep(0.,1.,length(x));}return f/2.+.5;}void main(){vec2 z=v*vec2(1,l.z)-vec2(.4,0);vec3 y=vec3(3.5*cos(l.y),0,3.5*sin(l.y)),i=vec3(0,.5,0),w=normalize(i-y),s=normalize(cross(w,vec3(0,1,0))),r=normalize(cross(s,w));f=vec4(vec3(1,.95,.89)-max(l.x-(1.-length(z+vec2(.4,0)))*10.,1.)*x(300.*z+100.)*x(6.*z)*vec3(.7,.9,1)/8.-l.w*x(vec2(400)*(z.x-z.y)+200.*z)*e(y,normalize(z.x*s+z.y*r+1.5*w)),1);}`;

            //*/
            let vs = gl.createShader(gl.VERTEX_SHADER);
            gl.shaderSource(vs, vertexShader);
            gl.compileShader(vs);

            let fs = gl.createShader(gl.FRAGMENT_SHADER);
            gl.shaderSource(fs, input);
            gl.compileShader(fs);

            let program = gl.createProgram();
            gl.attachShader(program, vs);
            gl.attachShader(program, fs);
            gl.linkProgram(program);
            /*
        if (!gl.getShaderParameter(vs, gl.COMPILE_STATUS)) {
            console.log(gl.getShaderInfoLog(vs)); // eslint-disable-line no-console
        }

        if (!gl.getShaderParameter(fs, gl.COMPILE_STATUS)) {
            console.log(gl.getShaderInfoLog(fs)); // eslint-disable-line no-console
        }

        if (!gl.getProgramParameter(program, gl.LINK_STATUS)) {
            console.log(gl.getProgramInfoLog(program)); // eslint-disable-line no-console
        }
        //*/

            let nf = 1,
                tlast = 0;
            let calculateFrames = (timeRef) => {
                let animations = [1, 0, 1, 0, 1, 0, 2, 3, 4, 5, 6, 7, 8, 9, 8, 9, 8, 9, 10, 10, 11, 11, 11, 10, 12, 12, 12, 12, 10, 10];
                let lengths = [3, 0.18, 0.5, 2, 0.25];
                let t = timeRef - tlast;
                //let la = lengths[ca]; // + lengths[na]) / 2;
                if (t > lengths[ca]) {
                    t -= lengths[ca];
                    tlast = timeRef;
                    if (ca != na) {
                        ca = oa;
                        oa = na;
                    }
                    //la = lengths[ca]; // + lengths[na]) / 2;

                    nf = (nf + 1) % 6;
                }
                return [animations[ca * 6 + ((nf + 5) % 6)], animations[oa * 6 + nf], t / lengths[ca], timeRef < 3 ? 1 : 0];
            };

            let params = [
                gl.getAttribLocation(program, 'p'), //0
                gl.getUniformLocation(program, var_UFRAMES), //1 //4
                gl.getUniformLocation(program, var_UD), //2 //5
            ];
            let vertexData = new Float32Array([1, 1, 1, -1, -1, -1, -1, 1]);
            let vbuffer = gl.createBuffer();
            gl.bindBuffer(gl.ARRAY_BUFFER, vbuffer);
            gl.bufferData(gl.ARRAY_BUFFER, vertexData, gl.STATIC_DRAW);
            gl.useProgram(program);
            //model
            gl.uniform4fv(
                gl.getUniformLocation(program, var_UMODEL),
                new Float32Array([
                    9, -7, -2, 1, 9, -14, -2, 1, 0, -1, 10, 10, -9, -7, -2, 1, -9, -14, -2, 1, 0, -1, 10, 10, 9, 0, -2, 1, 6, -14, -2, 1, 1, 0, 10, 9, -9, 0, -2, 1, -6, -14, -2, 1,
                    1, 0, 10, 9, 6, 0, -2, 1, 6, -14, -2, 1, 2, 1, 8, 9, -6, 0, -2, 1, -6, -14, -2, 1, 2, 1, 8, 9, 0, 0, 0, 1, 0, 8, 0, 1, 3, 0, 5, 5, 0, 10, -2, 1, 0, 4, 1, 1, 4,
                    3, 9, 8, 0, 6, 8, 1, 0, 5, 10, 1, 4, 3, 1, 1, 20, 0, 0, 1, 0, 0, -5, 1, 5, 0, 8, 7, -20, 0, 0, 1, 0, 0, -5, 1, 5, 0, 8, 7, 0, -3, 0, 1, 0, -26, 0, 1, 6, 5, 6,
                    6, 0, -3, 0, 1, 0, -26, 0, 1, 7, 5, 6, 6, 0, 0, 0, 1, 0, -18, 0, 1, 8, 6, 6, 3, 0, 0, 0, 1, 0, -18, 0, 1, 9, 7, 6, 3, -8, 0, 0, 1, 8, 0, 0, 1, 10, 2, 10, 10, 0,
                    0, 8, 1, 0, -11, 11, 1, 10, 2, 2, 2, 2, -8, 8, 1, -2, -8, 8, 1, 10, 2, 3, 3, 0, 0, 0, 1, -3, -43, 0, 1, 11, 10, 10, 6, 0, 0, 0, 1, 3, -43, 0, 1, 12, 10, 10, 6,
                    3, 0, 0, 1, 3, -9, -2, 1, 13, 11, 6, 7, 3, -9, -2, 1, 0, -36, 0, 1, 13, 11, 7, 4, -3, 0, 0, 1, -3, -9, -2, 1, 14, 12, 6, 7, -3, -9, -2, 1, 0, -36, 0, 1, 14, 12,
                    7, 4, 0, -5, 2, 1, 2, -13, 5, 1, 15, 8, 2, 1, 0, 0, 2, 1, -1, -17, 4, 1, 15, 8, 2, 1, -1, 0, 1, 1, -1, -18, 2, 1, 15, 8, 2, 1, -1, 0, 0, 1, -1, -17, 0, 1, 15,
                    8, 2, 1, 0, 0, 0, 1, -1, -15, -2, 1, 15, 8, 2, 1, 0, -5, 2, 1, -2, -13, 5, 1, 16, 9, 2, 1, 0, 0, 2, 1, 1, -17, 4, 1, 16, 9, 2, 1, 1, 0, 1, 1, 1, -18, 2, 1, 16,
                    9, 2, 1, 1, 0, 0, 1, 1, -17, 0, 1, 16, 9, 2, 1, 0, 0, 0, 1, 1, -15, -2, 1, 16, 9, 2, 1, 0, 2, 0, 1, 5, -15, 0, 1, 17, 13, 5, 1, 0, 2, 0, 1, 2, -15, 0, 1, 17,
                    13, 5, 1, 0, 2, 0, 1, 0, -14, 0, 1, 17, 13, 5, 1, 0, 2, 0, 1, -2, -13, 0, 1, 17, 13, 5, 1, 0, 2, 0, 1, -5, -12, 0, 1, 17, 13, 5, 1, 0, 2, 0, 1, -5, -15, 0, 1,
                    18, 14, 5, 1, 0, 2, 0, 1, -2, -15, 0, 1, 18, 14, 5, 1, 0, 2, 0, 1, 0, -14, 0, 1, 18, 14, 5, 1, 0, 2, 0, 1, 2, -13, 0, 1, 18, 14, 5, 1, 0, 2, 0, 1, 5, -12, 0, 1,
                    18, 14, 5, 1,
                ])
            );
            // poses
            gl.uniform4fv(
                gl.getUniformLocation(program, var_UPOSES),
                new Float32Array([
                    0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 71, 71, 0, 0, -71, 71, 0, 71, 0, 71, 0, -71, 0, 71, 0, 0, 0, 100, 0,
                    0, 0, 100, 0, -71, 0, 71, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 69, 0, 0, 72, 69, 0, 0, 72, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0,
                    100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 84, 54, 0, 0, -84, 54, 0, 71, 0, 71, 0, -71, 0, 71, 0, 0, 0, 100, 0, 0, 20, 98, 22, -65, -16, 71, 0, 0, 0, 100, 0, 0, 0,
                    100, 0, 0, 0, 100, 0, 0, 0, 100, 71, 0, 0, 70, 69, 0, 0, 72, -15, 0, 0, 99, 5, 0, 0, 100, -10, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 23, -38, 8,
                    89, -64, 4, -3, 76, 87, 0, 0, 50, 78, 0, 0, 62, -5, 0, 0, 100, 5, 0, -5, 100, 78, 3, 4, 62, -43, 0, 0, 90, -64, 0, 0, 76, 0, 0, 0, 100, 15, 0, 0, 99, 64, 0, 0,
                    76, 78, 0, 0, 62, -15, 0, 0, 99, 5, 0, 0, 100, -10, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, -6, -9, 10, 99, -24, 14, -4, 96, 67, -11, -10, 72, 52,
                    -3, 4, 85, -5, 0, 0, 100, 30, 9, -3, 95, 51, -4, 6, 86, -89, 0, 0, 45, -34, 0, 0, 94, 0, 0, 0, 100, 15, 0, 0, 99, 68, 4, 3, 73, 72, 0, 0, 70, -15, 0, 0, 99, 5,
                    0, 0, 100, -10, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, -38, -6, 5, 92, 4, 6, -12, 99, 52, 0, 0, 85, 69, 12, 19, 69, -5, 0, 0, 100, 71, 11, -7, 70,
                    20, -1, 5, 98, -87, 0, 0, 50, -15, 0, 0, 99, 10, 0, 0, 100, 5, 0, 0, 100, 64, 8, 6, 76, 81, 0, 0, 58, -15, 0, 0, 99, 5, 0, 0, 100, -10, 0, 0, 100, 0, 0, 0, 100,
                    0, 0, 0, 100, 0, 0, 0, 100, -64, -4, 3, 76, 23, 38, -8, 89, 78, 0, 0, 62, 87, 0, 0, 50, -5, 0, 0, 100, 78, -3, -4, 62, 5, 0, 5, 100, -64, 0, 0, 76, -43, 0, 0,
                    90, 15, 0, 0, 99, 0, 0, 0, 100, 78, 0, 0, 62, 64, 0, 0, 76, -15, 0, 0, 99, 5, 0, 0, 100, -10, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, -24, -14, 4,
                    96, -6, 9, -10, 99, 52, 3, -4, 85, 67, 11, 10, 72, -5, 0, 0, 100, 51, 4, -6, 86, 30, -9, 3, 95, -34, 0, 0, 94, -89, 0, 0, 45, 15, 0, 0, 99, 0, 0, 0, 100, 72, 0,
                    0, 70, 68, -4, -3, 73, -15, 0, 0, 99, 5, 0, 0, 100, -10, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 4, -6, 12, 99, -38, 6, -5, 92, 69, -12, -19, 69,
                    52, 0, 0, 85, -5, 0, 0, 100, 20, 1, -5, 98, 71, -11, 7, 70, -15, 0, 0, 99, -87, 0, 0, 50, 5, 0, 0, 100, 10, 0, 0, 100, 81, 0, 0, 58, 64, -8, -6, 76, -2, 0, 0,
                    100, 6, 0, 0, 100, -5, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, -2, 1, 61, 80, -6, 1, 0, 100, 52, 48, 52, 48, 26, 2, 0, 97, 0, 0, 0, 100, 7, 0, 0,
                    100, 7, 0, 0, 100, -13, 0, 0, 99, -13, 0, 0, 99, 0, 0, 0, 100, 7, 0, 0, 100, 74, 0, 0, 67, 74, 0, 0, 67, -2, 0, 0, 100, 6, 0, 0, 100, -5, 0, 0, 100, 0, 0, 0,
                    100, 0, 0, 0, 100, 0, 0, 0, 100, -2, 1, 61, 80, -2, 0, 0, 100, 64, 30, 64, 30, 15, 0, 0, 99, 0, 0, 0, 100, 7, 0, 0, 100, 7, 0, 0, 100, -13, 0, 0, 99, -13, 0, 0,
                    99, 0, 0, 0, 100, 7, 0, 0, 100, 74, 0, 0, 67, 74, 0, 0, 67, -2, 0, 0, 100, 6, 0, 0, 100, -5, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, -2, 0, 0, 100,
                    -2, 0, 0, 100, 15, 0, 0, 99, 15, 0, 0, 99, 0, 0, 0, 100, 7, 0, 0, 100, 7, 0, 0, 100, -13, 0, 0, 99, -13, 0, 0, 99, 0, 0, 0, 100, 7, 0, 0, 100, 74, 0, 0, 67, 74,
                    0, 0, 67, 10, 0, 5, 99, -5, 20, -1, 98, -5, 10, 0, 99, -19, -24, 5, 95, 0, 0, 0, 100, 0, 0, 0, 100, 71, 67, -9, 19, 12, -1, -36, 92, 0, 0, -84, 54, -59, -55,
                    45, 38, 0, 0, 0, 100, 29, 18, 8, 94, -8, -18, -10, 98, -49, 8, -5, 86, -19, 19, 4, 96, -7, -24, -29, 93, -19, 94, -5, 26, 84, 0, 0, 54, 69, 0, 0, 72, 0, 0, 0,
                    100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 88, 13, 7, 45, 0, 0, 0, 100, 74, -26, -40, 47, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0,
                    100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 0, 0, 0, 100, 69, 0, 0, 72, 69, 0, 0, 72,
                ])
            );
            //bones
            gl.uniform4fv(
                gl.getUniformLocation(program, var_UBONES),
                new Float32Array([
                    0, 96, 0, -1, 0, -18, 0, 0, 0, -18, 0, 1, 0, 0, 0, 0, 0, 7, 0, 3, 0, 0, 0, 0, -21, 0, 0, 5, 21, 0, 0, 5, 0, -27, 0, 6, 0, -27, 0, 7, 0, -18, 0, 2, -7, 0, 0, 10,
                    7, 0, 0, 10, -6, -41, 0, 11, 6, -41, 0, 12, 0, -17, 0, 8, 0, -17, 0, 9, 0, -39, 0, 13, 0, -39, 0, 14,
                ])
            );
            return (t, d) => {
                let cafi = calculateFrames(t);
                gl.uniform4fv(params[1], cafi);
                gl.uniform4fv(params[2], d); // burn, a, ratio, dim);
                gl.enableVertexAttribArray(params[0]);
                gl.vertexAttribPointer(params[0], 2, gl.FLOAT, false, 0, 0);

                gl.drawArrays(gl.TRIANGLE_FAN, 0, 4);
            };
        };

        let bg = BGRenderer(canvas.getContext('webgl2'));

        let refresh = () => {
            let t = performance.now() / 1000 - started;
            //let a = ;
            let inter = (d, start, end, from, to) => {
                if (t > end) {
                    return to;
                }
                if (t > start) {
                    let dt = (t - start) / (end - start);
                    return from * (1 - dt) + to * dt;
                }
                return d;
            };

            textnode.style.opacity = inter(inter(inter(inter(0, 5, 10, 0, 1), 15, 20, 1, 0), 25, 30, 0, 1), 70, 100, 1, 0);
            na = t < 48 ? 0 : t < 70 ? 1 : t < 86 ? 3 : t < 89 ? 4 : t < 100 ? 1 : t < 108 ? 2 : 4;
            if (rec && t > 20) rec = rec();

            bg(t > 35 ? t - 35 : 0, [
                inter(inter(60, 15, 25, 60, 1), 112, 120, 1, 60), // fade in out
                (Math.PI / 2) * (t > 45 ? 1 + (0.7 * Math.sin((t - 45) * 0.5)) / 2 : 1), // angle
                canvas.clientHeight / canvas.clientWidth,
                inter(inter(0, 7, 15, 0, 1), 105, 112, 1, 0), //man fade in out
            ]);
            if (t < 120) requestAnimationFrame(refresh);
            else {
                document.exitFullscreen();
                b.innerHTML = 'by tmptknn<br><br>Greets<br>Karoliina<br>bsh<br>Kahvi<br>Zouppen<br>The Old Dude<br>JJ<br>Morph<br>Instanssi';
            }
        };

        refresh();
    };
